; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "DetexGUI"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Tom Ford"
!define PRODUCT_WEB_SITE "http://urchin.earth.li/~tomford/detex/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\DetexGUI.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "..\license.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\DetexGUI.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "DetexGUI-1.0.exe"
InstallDir "$PROGRAMFILES\DetexGUI"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\bin\Release\DetexGUI.exe"
  CreateDirectory "$SMPROGRAMS\DetexGUI"
  CreateShortCut "$SMPROGRAMS\DetexGUI\DetexGUI.lnk" "$INSTDIR\DetexGUI.exe"
  CreateShortCut "$DESKTOP\DetexGUI.lnk" "$INSTDIR\DetexGUI.exe"
  File "..\bin\Release\detex.dll"
  File "..\bin\Release\config.xml"
  SetOutPath "$INSTDIR\detex"
  SetOverwrite try
  File "..\detex\detex-2.7\detex.1l"
  File "..\detex\detex-2.7\detex.h"
  File "..\detex\detex-2.7\detex.l"
  File "..\detex\detex-2.7\lexout.c"
  File "..\detex\detex-2.7\Makefile"
  SetOutPath "$INSTDIR\detex\os2"
  File "..\detex\detex-2.7\os2\detex-32.def"
  File "..\detex\detex-2.7\os2\detex.def"
  File "..\detex\detex-2.7\os2\makefile.os2"
  File "..\detex\detex-2.7\os2\README"
  SetOutPath "$INSTDIR\detex"
  File "..\detex\detex-2.7\README"
  File "..\detex\detex-2.7\states.sed"
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\DetexGUI\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\DetexGUI\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\DetexGUI.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\DetexGUI.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\detex\states.sed"
  Delete "$INSTDIR\detex\README"
  Delete "$INSTDIR\detex\os2\README"
  Delete "$INSTDIR\detex\os2\makefile.os2"
  Delete "$INSTDIR\detex\os2\detex.def"
  Delete "$INSTDIR\detex\os2\detex-32.def"
  Delete "$INSTDIR\detex\Makefile"
  Delete "$INSTDIR\detex\lexout.c"
  Delete "$INSTDIR\detex\detex.l"
  Delete "$INSTDIR\detex\detex.h"
  Delete "$INSTDIR\detex\detex.1l"
  Delete "$INSTDIR\config.xml"
  Delete "$INSTDIR\detex.dll"
  Delete "$INSTDIR\DetexGUI.exe"

  Delete "$SMPROGRAMS\DetexGUI\Uninstall.lnk"
  Delete "$SMPROGRAMS\DetexGUI\Website.lnk"
  Delete "$DESKTOP\DetexGUI.lnk"
  Delete "$SMPROGRAMS\DetexGUI\DetexGUI.lnk"

  RMDir "$SMPROGRAMS\DetexGUI"
  RMDir "$INSTDIR\detex\os2"
  RMDir "$INSTDIR\detex"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd