#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern FILE *yyerr;
extern FILE *yyout;

int main(int cArgs,char *rgsbArgs[]);

__declspec(dllexport) detex_dll_main(const char *filename, const char *latexfile, const char *errorfile) {
	
	char *args[2];
	const char *progname = "detex";
	int ret;
	int null_filename = 0;

	FILE *stderr_file;
	FILE *stdout_file;

	//Redirect stderr to a file
	stderr_file = fopen(errorfile,"w");
	
	if(stderr_file != NULL) {
		yyerr = stderr_file;
	}
	
	//Redirect stdout to a file
	stdout_file = fopen(latexfile,"w");

	if(stdout_file != NULL) {
		yyout = stdout_file;
	}
	else {
		//Not being able to write latex.tmp is critical failure
		return(2);
	}

	//Set cmd line arguments
	args[0] = strdup(progname);

	if(filename != NULL) {
		args[1] = strdup(filename);
	}
	else {
		args[1] = strdup("");
		null_filename = 1;
	}
	
	//Run
	if(null_filename) {
		ret = 1;
	}
	else {
		ret = main(2, args);
	}

	//Free memory
	free(args[0]);
	free(args[1]);
	
	//Close files
	if(stderr_file != NULL) {
		fclose(stderr_file);
	}
	
	if(stdout_file != NULL) {
		fclose(stdout_file);
	}

	return(ret);
}
